import java.io.*;

public class B {

    static class Ans {
        private long min;
        private String state;
        private long k;

        public Ans(long min, String state, long k) {
            this.min = min;
            this.state = state;
            this.k = k;
        }
    }

    public static Ans h(long n, long m) {
        long min = Long.MAX_VALUE;
        long k_ans = 0;
        for (int k = 0; k <= n; ++k) {
            long cur = Math.abs(((n*m)*(n*m + 1)/2) - k*m*(k*m + 1));
            if (cur < min) {
                min = cur;
                k_ans = k;
            }
            else if (cur > min) {
                break;
            }
        }
        return new Ans(min, "H", k_ans + 1);
    }

    public static Ans v(long n, long m) {
        long min = Long.MAX_VALUE;
        long k_ans = 0;
        if (n == 1) {
            for (int k = (int) m/2; k <= m; ++k) {
                long cur = Math.abs((n * m * (n * m + 1)) / 2 - 2 * ((k * m * (n - 1) * n) / 2 + (n * k * (k + 1)) / 2));
                if (cur < min) {
                    min = cur;
                    k_ans = k;
                } else if (cur > min) {
                    break;
                }
            }
        }
        else {
            for (int k = 0; k <= m; ++k) {
                long cur = Math.abs((n * m * (n * m + 1)) / 2 - 2 * ((k * m * (n - 1) * n) / 2 + (n * k * (k + 1)) / 2));
                if (cur < min) {
                    min = cur;
                    k_ans = k;
                } else if (cur > min) {
                    break;
                }
            }
        }
        return new Ans(min, "V", k_ans + 1);
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(System.out));
        int t = Integer.parseInt(reader.readLine());
        for (int i = 0; i < t; ++i) {
            String[] input = reader.readLine().split(" ");
            long n = Long.parseLong(input[0]);
            long m = Long.parseLong(input[1]);
            Ans h = h(n, m);
            Ans v = v(n, m);
            if (v.min <= h.min) {
                writer.write(v.state + " " + v.k + "\n");
            }
            else {
                writer.write(h.state + " " + h.k + "\n");
            }
        }
        writer.close();
    }
}
