import java.io.*;
import java.util.ArrayList;

public class C {

    private static ArrayList<Element> elements;

    private static long max = Long.MIN_VALUE;
    private static int ans_max = 2;
    private static long x_max = 1;
    private static char base_max = 'a';

    private static long min = Long.MIN_VALUE;
    private static int ans_min = 2;
    private static long x_min = 1;
    private static char base_min = 'a';

    static class Element {
        private char base;
        private long len;
        private long string_len;

        public Element (char base, long len) {
            this.base = base;
            this.len = len;
            string_len = len == 1 ? 1 : String.valueOf(len).length() + 1;
        }
    }

    public static long countLenOfNum(long num) {
        if (num == 1 || num == 0) {
            return 0;
        }
        return String.valueOf(num).length();
    }

    public static void insert() {
        long loc_max = 0;
        int y = 0;
        long x = 0;
        char old_base = 'a';
        long cur_sum = 0;
        for (int i = 0; i < elements.size(); ++i) {
            cur_sum += elements.get(i).len;
            if (elements.get(i).len > loc_max) {
                loc_max = elements.get(i).len;
                old_base = elements.get(i).base;
                x += cur_sum;
                y = i;
            }
        }
        x -= loc_max;
        long old_len = elements.get(y).string_len;

        if (loc_max == 1) {
            if (1 > max) {
                max = 1;
                ans_max = 1;
                x_max = 1;
                if (old_base == 'A') {
                    base_max = 'C';
                } else {
                    base_max = 'A';
                }
            }
        }
        else {
            long new_len1 = countLenOfNum(loc_max / 2) + 1 + 1 + countLenOfNum(loc_max - (loc_max / 2)) + 1;
            long x1 = x + loc_max / 2 + 1;

            long power = 0;
            long new_len2 = 0;
            String new_num = "";
            while (loc_max >= 10) {
                new_num = (loc_max % 10) + new_num;
                loc_max /= 10;
                ++power;
            }
            if (new_num.equals("")) {
                new_len2 = countLenOfNum((long) (loc_max * Math.pow(10, power))) + 1 + 1;
            } else {
                new_len2 = countLenOfNum((long) (loc_max * Math.pow(10, power))) + 1 + 1 + countLenOfNum(Integer.parseInt(new_num)) + 1;
            }
            long x2 = (long) (x + loc_max * Math.pow(10, power) + 1);

            if (new_len1 >= new_len2) {
                if (new_len1 - old_len > max) {
                    max = new_len1 - old_len;
                    ans_max = 1;
                    x_max = x1;
                    if (old_base == 'A') {
                        base_max = 'C';
                    } else {
                        base_max = 'A';
                    }
                }
            } else {
                if (new_len2 - old_len > max) {
                    max = new_len2 - old_len;
                    ans_max = 1;
                    x_max = x2;
                    if (old_base == 'A') {
                        base_max = 'C';
                    } else {
                        base_max = 'A';
                    }
                }
            }
        }
    }

    public static void erase() {
        long loc_min = Long.MIN_VALUE;
        long cur_x = 0;
        long x = 0;
        for (int i = 0; i < elements.size(); ++i) {
            cur_x += elements.get(i).len;
            if (elements.get(i).len == 1 && i > 0 && i < elements.size() - 1 && elements.get(i - 1).base == elements.get(i + 1).base) {
                long new_len = elements.get(i - 1).string_len + elements.get(i + 1).string_len + 1 -
                        countLenOfNum(elements.get(i - 1).len + elements.get(i + 1).len) - 1;
                if (new_len > loc_min) {
                    loc_min = new_len;
                    x = cur_x;
                }
            }
            if (elements.get(i).len == 1) {
                if (1 > loc_min) {
                    loc_min = 1;
                    x = cur_x;
                }
            }
            else {
                if (countLenOfNum(elements.get(i).len) > countLenOfNum(elements.get(i).len - 1)) {
                    long new_len = countLenOfNum(elements.get(i).len - 1) + 1;
                    if (new_len > loc_min) {
                        loc_min = new_len;
                        x = cur_x;
                    }
                }
            }
        }
        if (loc_min > min) {
            min = loc_min;
            ans_min = 2;
            x_min = x;
        }
    }

    public static void substitution() {
        long loc_max = 0;
        long x = 0;
        int y = 0;
        char old_base = 'a';
        long cur_sum = 0;
        for (int i = 0; i < elements.size(); ++i) {
            cur_sum += elements.get(i).len;
            if (elements.get(i).len > loc_max) {
                loc_max = elements.get(i).len;
                y = i;
                old_base = elements.get(i).base;
                x = cur_sum;
            }
        }
        x -= loc_max;
        long old_len = elements.get(y).string_len;

        if (loc_max == 1) {
            return;
        }
        else {
            long new_len1 = countLenOfNum(loc_max / 2) + 1 + 1 + countLenOfNum(loc_max - (loc_max / 2) - 1) + 1;
            long x1 = x + loc_max / 2 + 1;

            long power = 0;
            long new_len2 = 0;
            String new_num = "";
            while (loc_max >= 10) {
                new_num = (loc_max % 10) + new_num;
                loc_max /= 10;
                ++power;
            }
            if (new_num.equals("")) {
                new_len2 = countLenOfNum((long) (loc_max * Math.pow(10, power))) + 1 + 1;
            } else {
                new_len2 = countLenOfNum((long) (loc_max * Math.pow(10, power))) + 1 + 1 + countLenOfNum(Integer.parseInt(new_num) - 1) + 1;
            }
            long x2 = (long) (x + loc_max * Math.pow(10, power) + 1);

            if (new_len1 > new_len2) {
                if (new_len1 - old_len > max) {
                    max = new_len1 - old_len;
                    ans_max = 3;
                    x_max = x1;
                    if (old_base == 'A') {
                        base_max = 'C';
                    } else {
                        base_max = 'A';
                    }
                }
            } else {
                if (new_len2 - old_len > max) {
                    max = new_len2 - old_len;
                    ans_max = 3;
                    x_max = x2;
                    if (old_base == 'A') {
                        base_max = 'C';
                    } else {
                        base_max = 'A';
                    }
                }
            }
        }

        long loc_min = Long.MIN_VALUE;
        x = 0;
        long cur_x = 0;
        char base = 'a';
        for (int i = 0; i < elements.size(); ++i) {
            cur_x += elements.get(i).len;
            if (elements.get(i).len == 1 && i > 0 && i < elements.size() - 1 && elements.get(i - 1).base == elements.get(i + 1).base) {
                long new_len = elements.get(i - 1).string_len + elements.get(i).string_len + elements.get(i + 1).string_len -
                        countLenOfNum(elements.get(i - 1).len + 1 + elements.get(i + 1).len) - 1;
                if (new_len > loc_min) {
                    loc_min = new_len;
                    base = elements.get(i - 1).base;
                    x = cur_x;
                }
            }
            if (elements.get(i).len == 2 && i - 1 >= 0) {
                if (1 > loc_min) {
                    loc_min = 1;
                    --cur_x;
                    base = elements.get(i - 1).base;
                    x = cur_x;
                }
            }
            else if (elements.get(i).len > 2 && i - 1 >= 0){
                if (countLenOfNum(elements.get(i).len) > countLenOfNum(elements.get(i).len - 1)) {
                    long new_len = countLenOfNum(elements.get(i).len - 1) + 1;
                    if (new_len > loc_min) {
                        loc_min = new_len;
                        cur_x -= (elements.get(i).len + 1);
                        base = elements.get(i - 1).base;
                        x = cur_x;
                    }
                }
            }
        }
        if (loc_min > min) {
            min = loc_min;
            ans_min = 3;
            x_min = x;
            base_min = base;
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(System.out));
        String line = reader.readLine();
        elements = new ArrayList<>();
        String num = "";
        for (int i = 0; i < line.length(); ++i) {
            char sym = line.charAt(i);
            if (sym != 'A' && sym != 'C' && sym != 'G' && sym != 'T') {
                num += sym;
            }
            else {
                if (num.equals("")) {
                    elements.add(new Element(sym, 1));
                }
                else {
                    elements.add(new Element(sym, Integer.parseInt(num)));
                    num = "";
                }
            }
        }
        insert();
        erase();
        substitution();
        if (ans_min == 1) {
            writer.write("1 " + x_min + " " + base_min + "\n");
        }
        else if (ans_min == 2) {
            writer.write("2 " + x_min + '\n');
        }
        else {
            writer.write("3 " + x_min + " " + base_min + "\n");
        }
        if (ans_max == 1) {
            writer.write("1 " + x_max + " " + base_max + "\n");
        }
        else if (ans_max == 2) {
            writer.write("2 " + x_max + '\n');
        }
        else {
            writer.write("3 " + x_max + " " + base_max + "\n");
        }
        writer.close();
    }
}
